import{geoCentroid,zoom,event} from 'd3'

export const usMap = (selection, props) => {
  const {
  pathGenerator,
  stateMap,
  data,
  sizeScale,
  radiusValue,
  svg,
  dates,
  csvData,
  usedDate
  } = props;
  
  svg.call(zoom().on('zoom', ()=>{
  selection.attr('transform', event.transform)
  }));
  
  const daySales = csvData.filter(d => d.Date ===dates[usedDate]) 
  

  const rowById = daySales.reduce((accumulator, d) => {
    accumulator[d['id']] = d;
      return accumulator;     
  }, {});
  
  data.features.forEach(d => { 
    Object.assign(d.properties,rowById[d.id]);
  });

  
  const statePath = selection.selectAll('path')
    .data(data.features);
  statePath
    .enter().append('path')
  	.attr('class', 'states')
  .merge(statePath)
    .attr('d', pathGenerator(stateMap)) 
    .attr('fill', d => d.properties['TotalVolume'] ? '#fecccc' : '#e8e8e8')
  	.append('title')
  	.text(d => d.properties['State']
            ? [d.properties['State'],d.properties['TotalVolume']].join(': ') 
            : 'Missing Data');
  
  const stateCircle = 
  selection.selectAll('circle').data(data.features)
    .attr("class","state-circle") 
  console.log()
  stateCircle
    .enter().append("circle")
    .attr('cx', d => stateMap(geoCentroid(d))[0])
    .attr('cy', d => stateMap(geoCentroid(d))[1])
    .attr('r',0)
  .merge(stateCircle)
    .attr('r',d => sizeScale(radiusValue(d)));
}; 